unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Handles, StdCtrls, ExtCtrls, QRCtrls, QuickRpt, ComCtrls,
  Menus;

type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    test1: TMenuItem;
    StretchHandle1: TStretchHandle;
    Label1: TLabel;
    Memo1: TMemo;
    Shape1: TShape;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    QuickRep1: TQuickRep;
    QRBand1: TQRBand;
    QRLabel1: TQRLabel;
    QRDBText1: TQRDBText;
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Button1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Drawing: Boolean;
    Origin, MovePt: TPoint;
    procedure DrawShape(TopLeft, BottomRight: TPoint; AMode: TPenMode);
    Function InSelectArea(x1,y1,x2,y2:integer;value:TControl):Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Function TForm1.InSelectArea(x1,y1,x2,y2:integer;value:TControl):Boolean;
var
  SLeft,STop,SWidth,SHeight:integer;
begin
     if x2>x1 then
         SLeft:=x1
     else
         SLeft:=x2;

     if y1>y2 then
         STop:=y2
     else
         STop:=y1;

     SWidth:=Abs(x1-x2);
     SHeight:=Abs(y1-y2);

     IF (value.Top>=STop) and (value.Left>=SLeft) and (Value.Left+value.Width<=SLeft+SWidth) and (value.Top+value.Height<=STop+SHeight) then
         result:=True
     else
         result:=False;
end;

procedure TForm1.DrawShape(TopLeft, BottomRight: TPoint; AMode: TPenMode);
begin
   Canvas.Pen.Mode := AMode;
   Canvas.Rectangle(TopLeft.X, TopLeft.Y, BottomRight.X,
       BottomRight.Y);
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  StretchHandle1.Locked := not StretchHandle1.Locked;
  if StretchHandle1.Locked then
    Button4.Caption := 'Unlock'
  else
    Button4.Caption := 'Lock';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  StretchHandle1.BringToFront;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  StretchHandle1.SendToBack;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  StretchHandle1.Detach;
  StretchHandle1.Locked := False;
  Button4.Caption := 'Lock';
end;

procedure TForm1.Button1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (GetKeyState(VK_SHIFT) >= 0) then
  begin
     StretchHandle1.Detach;
     StretchHandle1.Locked := False;
  end;
  StretchHandle1.Attach(TButton(sender));
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if Drawing then
  begin
    DrawShape(Origin, MovePt, pmNotXor);
    MovePt := Point(X, Y);
    DrawShape(Origin, MovePt, pmNotXor);
  end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Drawing := True;
   Canvas.MoveTo(X, Y);
   Origin := Point(X, Y);
   MovePt := Origin;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i:integer;
begin
   if Drawing then
   begin
      DrawShape(Origin, Point(X, Y), pmNotXor);
      Drawing := False;
      With Self do
      begin
         For i:=0 to ComponentCount-1 do
         begin
            if InSelectArea(Origin.X,Origin.Y,X,Y,Tcontrol(Components[i])) then
            begin
               if not(Components[i] is TStretchHandle) then
                  StretchHandle1.Attach(Tcontrol(Components[i]));
            end;
         end;
      end;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   TButton(QRBand1).OnMouseDown:=Button1MouseDown;
   TButton(QRLabel1).OnMouseDown:=Button1MouseDown;
   TButton(QRDBText1).OnMouseDown:=Button1MouseDown;
end;

end.
